/**
 * @template T, U
 * @param {(acc: U, value: T) => U} f
 * @param {U} acc
 */
export const Reducer = (f, acc) => {
  /** @template A */
  return class Const {
    /** @param {A} value */
    constructor(value) {
      this.value = value
    }

    static of() { return new Const(acc) }

    map() { return this }

    /**
     * @this {Const<T>}
     * @param {Const<U>} b
     */
    ap(b) {
      return new Const(f(b.value, this.value))
    }
  }
}
